import React, { Component }  from 'react';
import { eventManager } from './utils/eventManager'
import { EDP_SUBMENU } from '../css-class-token'
import { stringCleaner } from '../../util'

import { Portal } from './Portal';
class Submenu extends Component  {
    componentDidUpdate() {
        eventManager.on(`HIDE_SUBMENU`, this.hiddenSubMenu);
    }

    componentWillUnmount() {
        const allSubMenu =  document.querySelectorAll('.' + EDP_SUBMENU);
        if (allSubMenu) {
            allSubMenu.forEach(el => document.body.removeChild(el))
        }
    }

    hiddenSubMenu() {
        Array.from(document.querySelectorAll(`.${EDP_SUBMENU}`)).map(ele => ele.style.visibility = 'hidden')
    }




    render() {
        
        const {
            item,
            suBmenuId,
            style,
            idMenuToShow,
            handleClick,
            rowId,
            rowItem
        } = this.props;

        
        return (
            <Portal style={style} suBmenuId={suBmenuId} idMenuToShow={idMenuToShow} item={item} rowId={rowId} rowItem={rowItem}>
                <ul>
                    {item.map(ctx => {  
                        return (
                        <li onClick={event => handleClick(ctx)} id={`${stringCleaner(ctx.name)}___${stringCleaner(rowId)}_${EDP_SUBMENU}`}>
                            <div className="name-submenu">
                                {ctx.name}
                            </div>
                        </li>
                    )})}
                </ul>
            </Portal>
        );
    }
}

export { Submenu };
