import React, { Component } from 'react';
import DragUtilizadores from './SelecionarUtilizador/DragComponent/DragUtilizadores';
import { Treebeard } from 'react-treebeard';
// import { connect } from 'react-redux';

// import {
//     loadUserFromTree,
//     searchUsersByNameOrId,
//     cleanContatosInternos,
//     loadAllTrees,
//     getEmpresas,
//     addUser,
//     addUserCC
// } from '../service-calls/stepDelegation'

import './SelecionarUtilizador/selecionarUtilizador.scss';
import './SelecionarUtilizador/selecionarUtilizador.css';
import { tree } from './SelecionarUtilizador/Util/cssIn';

import GroupTaskRow from './SelecionarUtilizador/Shared/GroupTaskRow'
import MinhaEquipaBtn from './SelecionarUtilizador/Shared/MinhaEquipaBtn'
// import { setNotifyBack, setBeforeBack, setGoBack } from '../service-calls/stepActions';

import { SearchField } from './SelecionarUtilizador/SearchField/SearchField';
import { Dropdown } from './SelecionarUtilizador/Dropdown/Dropdown';
import { MuiThemeProvider } from '@material-ui/core';
import addedDecorators from './SelecionarUtilizador/Util/treebeardDecorator'; 
import theme from './SelecionarUtilizador/Util/FormTheme';
import { CONTRATOS_DRAG_CC, CONTRATOS_DRAG_UTILIZADORES } from './SelecionarUtilizador/UserSelectionForward';

export class SelecionarUtilizador extends Component {
    constructor(props) {
        super(props);

        this.state = {
            userSelecionadoBusca: [],
            utilizador: sessionStorage.getItem('name')
            && JSON.parse(sessionStorage.getItem('name')),
            encaminhar: this.props.encaminhar || false,
            eSecreto: this.props.eSecreto || false,
            radioButton: 'user',
            showOrganizations:true,
            selectedCompanyValue: JSON.parse(sessionStorage.name).company.id,

            properties: {
                EDP_usersCC:[],
                EDP_usersACL: [],
                EDP_POUsersArray: [],
                EDP_UNUsersArray: [],
                EDP_UOUsersArray: []
            }
        };

        this.props.setBeforeBack(true);
    }

    isUtilizadoresCC() {
        console.log('------ utilizadores CC', this.props.conteudoUtilizadores);
        console.log( this.props);
        return this.props.conteudoUtilizadores === CONTRATOS_DRAG_CC;
    }

    componentDidMount() {
        this.props.loadAllTrees();
        this.props.getEmpresas();
    }

    componentWillUnmount() {
        this.setState({showOrganizations:false})
    }

    componentDidUpdate(prevProps) {
        if(this.props.notifyBack){
            console.log('SET STATE SHOW FALSE')
            this.setState({showOrganizations:false})
            this.props.setGoBack(true);
        }

        if (prevProps.contatosTree.length !== this.props.contatosTree.length) {
            this.setState({
                userSelecionadoBusca: [
                    ...this.state.userSelecionadoBusca,
                    ...this.props.contatosTree
                ]
            });
        }
    }

    selectUserPesquisa = user => {
        const results = user.POs.map(pos => ({ ...user, ...pos }));
        const userWithId = results.map(user => ({ ...user, stringifyId: JSON.stringify(user) }) )
        this.isUtilizadoresCC()? this.props.addUserComponentCC(userWithId): this.props.addUserCompnonent(userWithId)
    };

    onToggle = (node, toggled) => {
        this.props.loadUserFromTree(node);

        node.active = true;
        if (node.children) {
            node.toggled = toggled;
        }
        this.setState({ cursor: node });
    };

    loadMinhaEquipa = () => {
        this.props.loadUserFromTree({
            actionType: 'getMyTeam'
        });
    }

    onDropDownChange = target => {
        this.props.loadAllTrees(target.currentTarget.value);
        this.setState({ selectedCompanyValue: target.currentTarget.value })
    };

    render() {
        const {
            organizationContent,
            organizations,
            loadingContatos,
            onSubmit,
            usuariosPesquisa
        } = this.props;
        const { hidePOandUN } = this.props || false;
        const { tabConhecimento } = this.props || false;
        const  encaminhar = this.state.encaminhar;
        const  eSecreto = this.state.eSecreto;

        return (
            <MuiThemeProvider theme={theme}>
                <GroupTaskRow
                    options={{
                        user: 'Pessoa(s)',
                        org: 'Organização (Grupos/Equipas)'
                    }}
                    radioBtnValue={this.state.radioButton}
                    handleChange={value => this.setState({ radioButton: value })}
                    hideGroupRow={this.props.hideGroupRow}
                />
                <div className="col-lg-12 selecao__container">
                    <div className="col-lg-5 noPadding">
                        <SearchField
                            results={this.props.usuariosPesquisa}
                            userSearchLoading={this.props.loadingContatos}
                            addUser={this.selectUserPesquisa}
                            seachUsersByNameOrId={this.props.searchUsersByNameOrId}
                        />
                        {!hidePOandUN && (
                            <React.Fragment>
                                <Dropdown
                                    value={this.state.selectedCompanyValue} 
                                    options={this.props.organizationContent} 
                                    onChange={this.onDropDownChange} />
                                <div className="treebeard__container">
                                    {this.props.organizations && this.props.organizations.map((empresas, i) => {
                                        return(
                                        <Treebeard
                                            key={i}
                                            style={tree}
                                            data={empresas}
                                            onToggle={this.onToggle}
                                            decorators={addedDecorators}
                                        />
                                    )})}
                                    <MinhaEquipaBtn loadMinhaEquipa={this.loadMinhaEquipa}/>
                                </div>
                            </React.Fragment>
                        )}
                    </div>
                    <div className="col-lg-2"></div>
                    <div className="col-lg-5">
                        {!this.props.loadingContatos ? (
                            <DragUtilizadores
                                conteudoUtilizadores={this.props.conteudoUtilizadores?this.props.conteudoUtilizadores:CONTRATOS_DRAG_UTILIZADORES}
                                userSelecionado={this.state.userSelecionadoBusca}
                                onPublicacaoSubmit={users => onSubmit(users)}
                                tabConhecimento={tabConhecimento}
                                encaminhar={encaminhar}
                                eSecreto={eSecreto}
                                dontSave={this.props.dontSave}
                                groupValue={this.state.radioButton}
                            />
                        ) : (
                            'A transferir...'
                        )}
                    </div>
                </div>
            </MuiThemeProvider>
        );
    }
}

// const mapStateToProps = state => {
//     return {
//         usuariosPesquisa: state.stepDelegationReducer.contatos,
//         contatosTree: state.stepDelegationReducer.contatosTree, 
//         treeContent: state.stepDelegationReducer.treeContent,
//         organizationContent: state.stepDelegationReducer.organizationContent,
//         loadingContatos: state.stepDelegationReducer.loadingContatos,
//         organizations: state.stepDelegationReducer.organizations,
//         notifyBack : state.stepReducer.notifyBack
//     };
// };

// const mapDispatchToProps = dispatch => ({
//     searchUsersByNameOrId: (filter, state) => {
//         dispatch(searchUsersByNameOrId(filter, state));
//     },
//     setNotifyBack: value=>dispatch(setNotifyBack(value)),
//     setBeforeBack:value=>dispatch(setBeforeBack(value)),
//     addUserCompnonent: user => dispatch(addUser(user)),
//     addUserComponentCC: user => dispatch(addUserCC(user)),

//     loadAllTrees: empresaEscolhida => dispatch(loadAllTrees(empresaEscolhida)),
//     getEmpresas: () => dispatch(getEmpresas()),
//     cleanContatosInternos: () => dispatch(cleanContatosInternos()),
//     loadUserFromTree: node => dispatch(loadUserFromTree(node)),
//     setGoBack : value => dispatch (setGoBack(value))
// });

// export default connect(
//     mapStateToProps,
//     mapDispatchToProps
// )(SelecionarUtilizador);
