import React, { Component } from 'react';
import { DragDropContext, Droppable, Draggable } from 'react-beautiful-dnd';
import { reorder, getItemStyle, callModalMessages } from './constants/util';


import './dragUtilizadores.css';

// import { connect } from 'react-redux';
// import {
//     saveStep,
//     setPropertiesToSave,
//     notifySave,
//     setGoNext
// } from '../../../service-calls/stepActions';

// import { 
//     cleanContatosInternos, 
//     cleanContatosInternosCC,
//     selectAll, 
//     selectAllCC,
//     selectUser ,
//     selectUserCC
// } from '../../../service-calls/stepDelegation';

import Icon from 'react-edp-icons';

import { SimpleItemToSelect, CheckBoxWrapper } from './Shared/ItemToSelect';
import { CONTRATOS_DRAG_CC, CONTRATOS_DRAG_UTILIZADORES } from '../UserSelectionForward';

export class DragUtilizadores extends Component {
    constructor(props) {
        super(props);
        console.log('------PROPS---------', props)
        console.log('---------CONTEUDO DRAG UTILIZADORES-------', props[props.conteudoUtilizadores])
        this.state = {
            eSecreto: this.props.eSecreto || false,
            conteudoUtilizadores: props[props.conteudoUtilizadores],
            properties: {
                EDP_usersACL: [],
                EDP_usersCC:[],
                EDP_POUsersArray: [],
                EDP_UNUsersArray: [],
                EDP_UOUsersArray: [],
                EDP_CcArray: [],
                usersList: []
            },
            iconColor: '#ee162d'
        };
    }

    variavelUtilizadorRedux() {
        return this.props.conteudoUtilizadores?this.props[this.props.conteudoUtilizadores]:this.props[CONTRATOS_DRAG_UTILIZADORES];
    }

    componentDidUpdate(prevProps) {
        
        if (this.props.notifySaveController && !this.props.dontSave) {
            this.submitUsers();
        }
    }

    submitUsers() {
        const EDP_usersACL = [];
        const EDP_POUsersArray = [];
        const EDP_UNUsersArray = [];
        const EDP_UOUsersArray = [];
        const { onPublicacaoSubmit } = this.props;
        const conteudoUtilizadores = this.props [this.props.conteudoUtilizadores];
        
        const userSeleted = conteudoUtilizadores.filter(({ selected }) => selected);

        const usersList = [];
        if (userSeleted.length) {
            userSeleted.map(user => {
              
                EDP_usersACL.push(user.shortName);
                EDP_POUsersArray.push(user.PO_ShortName);
                EDP_UNUsersArray.push(user.UN_ShortName);
                EDP_UOUsersArray.push(user.UO_ShortName);


                if (this.props.encaminhar) {
                    usersList.push({
                        "name": user.displayName,
                        "un": user.UN_ShortName,
                        "po": user.PO_ShortName,
                        "poUser": user.PO_ShortName
                    });
                }

            });
            var newPropsToSave = {};
            if (this.props.encaminhar) {
                newPropsToSave = {
                    EDP_usersACL,
                    EDP_POUsersArray,
                    EDP_UNUsersArray,
                    EDP_UOUsersArray,
                    usersList
                };
            } else {
                newPropsToSave = {
                    EDP_usersACL,
                    EDP_POUsersArray,
                    EDP_UNUsersArray,
                    EDP_UOUsersArray
                };
            }

            console.log(
                '==== submitUsers DragUtilizadores ====',
                newPropsToSave
            );
            onPublicacaoSubmit(newPropsToSave);
        } else {
            if (this.props.onlySave === true) {
                callModalMessages({
                    messageType: 'alert',
                    messageBody: 'Atenção: De modo a avançar com o processo, selecione o(s) utilizador(es) de destino.'
                });
                this.props.notifySave(false);
                this.props.setGoNext(false);
            }
        }
    }

    onDragEnd = result => {
        if (!result.destination) return;

        const conteudoUtilizadores = reorder(
            this.state.conteudoUtilizadores,
            result.source.index,
            result.destination.index
        );

        this.setState({
            conteudoUtilizadores
        });
    };


    cleanSelection = event => {
        const userToNoClean = this.variavelUtilizadorRedux().filter(({ selected }) => selected);
        this.isUtilizadoresCC()?this.props.cleanContatosInternosCC(userToNoClean):this.props.cleanContatosInternos(userToNoClean);
    };

    changeColorLeave = () => {
        this.setState({ iconColor: '#ee162d' });
    };

    changeColorEnter = () => {
        this.setState({ iconColor: '#333333' });
    };

    handleSelectUser = user =>{
        const { eSecreto, conteudoUtilizadores } = this.state;

        if(eSecreto == true && !user.selected && conteudoUtilizadores.filter(user => user.selected).length >= 1){
            console.log("Apenas pode selecionar um utilizador");
        }else{
            this.isUtilizadoresCC()? this.props.selectUserCC(user)
            :this.props.selectUser(user);
        }
    }

    isUtilizadoresCC() {
        return this.props.conteudoUtilizadores == CONTRATOS_DRAG_CC;
    }

    render() {
        const {  iconColor } = this.state;
        const conteudoUtilizadores = this.variavelUtilizadorRedux();

        const checkboxHeaderActive = conteudoUtilizadores.filter(({ selected }) => selected).length;
        const isAllSelected = conteudoUtilizadores.filter(({ selected }) => selected).length === conteudoUtilizadores.length;

        return (
            <div className="DragDropContext__container">
                <div className="__header">
                    <div className="input__container">
                        <label className="label__container">
                            <CheckBoxWrapper isActive={checkboxHeaderActive} allSelected={isAllSelected} />
                            Selecione para Envio
                            <input
                                type="checkbox"
                                style={{ opacity: 0 }}
                                checked={checkboxHeaderActive}
                                onChange={()=>this.isUtilizadoresCC()?this.props.selectAllCC() :this.props.selectAll()}
                            />
                        </label>
                    </div>
                    <button
                        onClick={this.cleanSelection}
                        onMouseEnter={this.changeColorEnter}
                        onMouseLeave={this.changeColorLeave}
                        className={iconColor === '#333333' ? 'spinner' : ''}
                    >
                        <Icon
                            icon="RELOAD"
                            color={checkboxHeaderActive ? iconColor : '#333333'}
                            size={30}
                        />
                    </button>
                </div>
                {conteudoUtilizadores.length === 0 ? '' : (
                    <DragDropContext onDragEnd={this.onDragEnd}>
                        <Droppable droppableId="droppable">
                            {provided => (
                                <div
                                    ref={provided.innerRef}
                                    className="DragDropContext__list-container"
                                >
                                    {conteudoUtilizadores.map((user, index) => (
                                        <Draggable
                                            key={user.stringifyId}
                                            draggableId={user.stringifyId}
                                            index={index}
                                        >
                                            {(
                                                provided,
                                                snapshot
                                            ) => (
                                                    <div
                                                        ref={
                                                            provided.innerRef
                                                        }
                                                        {...provided.draggableProps}
                                                        {...provided.dragHandleProps}
                                                        className="__item"
                                                        style={getItemStyle(
                                                            snapshot.isDragging,
                                                            provided
                                                                .draggableProps
                                                                .style
                                                        )}
                                                    >
                                                        <SimpleItemToSelect
                                                            user={user}
                                                            selectUser={(e, user) => this.handleSelectUser(user)}
                                                            grupoSelect={this.props.groupValue}
                                                            allSelected={isAllSelected}
                                                        />
                                                    </div>
                                                )}
                                        </Draggable>
                                    ))}
                                    {provided.placeholder}
                                </div>
                            )}
                        </Droppable>
                    </DragDropContext>
                )}
            </div>
        );
    }
}

// const mapStateToProps = state => {
//     return {
//         notifySaveController: state.stepReducer.notifySave,
//         emails: state.stepDelegationReducer.emails,
//         contatosDragUtilizadores: state.stepDelegationReducer.contatosDragUtilizadores,
//         contatosDragCC: state.stepDelegationReducer.contatosDragCC
//     };
// };

// const mapDispatchToProps = dispatch => ({
//     saveStep: () => dispatch(saveStep()),
//     selectAll: () => dispatch(selectAll()),
//     selectUser: r => dispatch(selectUser(r)),
//     selectAllCC: () => dispatch(selectAllCC()),
//     selectUserCC: r => dispatch(selectUserCC(r)),
//     setPropertiesToSave: properties =>
//         dispatch(setPropertiesToSave(properties)),
//     cleanContatosInternos: userToNoClean => dispatch(cleanContatosInternos(userToNoClean)),
//     cleanContatosInternosCC: userToNoClean => dispatch(cleanContatosInternosCC(userToNoClean)),
//     notifySave: value => dispatch(notifySave(value)),
//     setGoNext: value => dispatch(setGoNext(value)),
// });

// export default connect(
//     mapStateToProps,
//     mapDispatchToProps
// )(DragUtilizadores);
