import React from 'react';
import CheckboxIcon from '@material-ui/icons/CheckBox';
import CheckboxBlankIcon from '@material-ui/icons/CheckBoxOutlineBlank';

export const CheckBoxWrapper = ({ isActive, allSelected }) => {
    if (allSelected) return <CheckboxIcon style={{ color: '#999' }} />;
    if (isActive) return <CheckboxIcon style={isActive ? { color: '#9E0616' } : { color: '#999' }} />;
    else return <CheckboxBlankIcon />;
};

export const SimpleItemToSelect = ({
    selectUser,
    user,
    allSelected,
    grupoSelect
}) => {
    return (
        <label className="label__container" onClick={e => selectUser(e, user)}>
            <CheckBoxWrapper isActive={user.selected} allSelected={allSelected} />
            <div className="__text-container">
                {grupoSelect === 'user' ?
                    <React.Fragment>
                        <h1>{user.displayName}</h1>
                        <p> {user.UN_DisplayName} - {user.UO_DisplayName}</p>
                    </React.Fragment>
                    : <h1>{user.UO_DisplayName}</h1>
                }
            </div>
        </label>
    );
};