export const isObjEmpty = obj => {
    var isEmpty = true;

    for (var i in obj) {
        if (obj.hasOwnProperty(i)) {
            isEmpty = false;
            break;
        }
    }
    return isEmpty;
};

const defaultMessage = {
    messageType: 'alert',
    messageBody: 'Atenção: Algo errado não está certo'
};

export const callModalMessages = (messages = defaultMessage) => {
    if (window.icnReactService) {
        window.icnReactService.sendMessage({
            message: 'render_modalMessagesReact',
            jsonArray: [messages]
        });
    } else {
        console.error('window.icnReactService WELL THIS WAS NOT SETTING');
    }
};

// a little function to help us with reordering the result
export const reorder = (list, startIndex, endIndex) => {
    const result = Array.from(list);
    const [removed] = result.splice(startIndex, 1);
    result.splice(endIndex, 0, removed);

    return result;
};

export const getItemStyle = (isDragging, draggableStyle) => ({
    // add boxShadow and border if dragging
    boxShadow: isDragging ? '0px 1px 25px 5px rgba(0,0,0,0.2)' : 'none',
    borderBottom: isDragging ? 0 : '1px solid #ddd',

    // styles we need to apply on draggables
    ...draggableStyle
});

export const shallowEqual = (objA, objB) => {
    if (objA === objB) {
        return true;
    }
    var key;
    // Test for A's keys different from B.
    for (key in objA) {
        if (
            objA.hasOwnProperty(key) &&
            (!objB.hasOwnProperty(key) || objA[key] !== objB[key])
        ) {
            return false;
        }
    }
    // Test for B's keys missing from A.
    for (key in objB) {
        if (objB.hasOwnProperty(key) && !objA.hasOwnProperty(key)) {
            return false;
        }
    }
    return true;
};

export function isArrayEqual(a, b) {
    if (a === b) return true;
    if (a == null || b == null) return false;
    if (a.length != b.length) return false;

    for (var i = 0; i < a.length; ++i) {
        if (a[i] !== b[i]) return false;
    }
    return true;
}
