import { createMuiTheme } from "@material-ui/core";
import { grey, red } from "@material-ui/core/colors";

export default createMuiTheme({
	palette: {
		primary: grey,
		secondary: red,
	},
	overrides: {
		MuiInput: {
			root: {
				width: "100%",
			},
			underline: {
				"&:before, &:after": {
					borderBottom: "1px solid #CCCCCC !important",
				},
			},
		},
		MuiMenuItem: {
			root: {
				fontSize: 16,
				fontStyle: "normal",
			},
		},
		MuiInputBase: {
			input: {
				fontSize: "16px",
				// marginTop: 4,
				color: "#333",
				lineHeight: "19px",
				padding: "2px 0 2px",
				boxSizing: "border-box",
				"&:focus, &:hover": {
					backgroundColor: "transparent",
				},
			},
		},
		MuiFormLabel: {
			root: {
				fontSize: 11,
				top: "-6px!important",
				lineHeight: "13px",
				margin: 0,
				color: "#999999",
				fontWeight: 500,
				"&$focused": {
					color: "#999999 !important",
				},
			},
			error: {
				color: "#f44336 !important",
				fontSize: "13px !important",
			},
			focused: {
				// color: '#999999 !important'
			},
			asterisk: {
				display: "none",
			},
		},
		MuiInputLabel: {
			shrink: {
				transform: "translate(0, 1.5px) scale(1) !important",
			},
		},
		MuiFormControl: {
			root: {
				display: "block",
				width: 350,
				marginBottom: 20,
			},
		},
    },
    typography: {
		useNextVariants: true,
	},
});
