import { promisseAmbiente } from '../../service-calls/navigator';

const getUsersPO = user => {
	return new Promise(async (resolve, reject) => {
		const environment = await promisseAmbiente();
		const serviceParams = {
			repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
			poEscolhida: user.PO_ShortName,
			realmName: 'dc=edp,dc=pt',
			ambiente: environment,
			username: JSON.parse(sessionStorage.name).onBehalfOf.id,
			actionType: 'getUsersPOReadpUps'
		};
		ecm.model.Request.invokePluginService('EdpECMServices', 'UserServices', {
			requestParams: serviceParams,
			requestCompleteCallback: response => {
				resolve({
					name: user.name,
					un: user.UN_ShortName,
					po: user.PO_ShortName,
					usersComAcesso: response.Users
				});
			}
		});
	});
};

export default getUsersPO
