import React from 'react'
import 'dayjs/locale/pt'
import dayjs from 'dayjs'
dayjs.locale('pt')

const TransformCell = ({ cell, row, field, callAction }) => {
    const date = /Date|Data|Time/i.test(field) && cell !== null ? dayjs(cell).format('DD-MM-YYYY HH:mm') : [];
    if(row.rowInfos.isFolder()){
        return <div className='react-contextmenu-wrapper'>{
            date.length ? date : cell
        }</div>
    }else{
        // Nas tabelas das inbaskets, o valor dos destinatários (EDP_BoundUserDisplayName) não deve ser um link 
        return /name|EDP_RefDossier/i.test(field) && field !== 'EDP_BoundUserDisplayName' ?
            <div className='react-contextmenu-wrapper'>
                <a
                    onClick={event => callAction(event, row)}
                    data-row={row.rowInfos.id}
                >
                    {cell}
                </a>
            </div> : 
            <div className='react-contextmenu-wrapper'>{
                date.length ? date : cell
            }</div>
        }
}
export default TransformCell;