import { promisseAmbiente } from './navigator';
import { DUM_SESSION } from '../constants/index';

export const SET_TREE_CONTENT = 'SET_TREE_CONTENT';
export const SET_ORGANIZATION_CONTENT = 'SET_ORGANIZATION_CONTENT';
export const SET_CREATE_DELEGATION = 'SET_CREATE_DELEGATION';
export const CONTATOS_INTERNOS = 'CONTATOS_INTERNOS';
export const CONTATOS_EXTERNOS = 'CONTATOS_EXTERNOS';
export const CLEAN_CONTATOS_INTERNOS = 'CLEAN_CONTATOS_INTERNOS';
export const CLEAN_CONTATOS_EXTERNOS = 'CLEAN_CONTATOS_EXTERNOS';
export const LOADING_CONTATOS_INTERNOS_PESQUISA =
    'LOADING_CONTATOS_INTERNOS_PESQUISA';
export const LOADING_CONTATOS_EXTERNOS_PESQUISA =
    'LOADING_CONTATOS_EXTERNOS_PESQUISA';
export const CONTATOS_TREE = 'CONTATOS_TREE';
export const FETCH_CONTATOS_INTERNOS = 'FETCH_CONTATOS_INTERNOS';
export const FETCH_CONTATOS_EXTERNOS = 'FETCH_CONTATOS_EXTERNOS';
export const CONTATOS_TREE_EXTERNALS = 'CONTATOS_TREE_EXTERNALS';
export const CLEAN_CONTATOS_TREE_EXTERNALS = 'CLEAN_CONTATOS_TREE_EXTERNALS';
export const SAVE_EMAIL_DATA = 'SAVE_EMAIL_DATA';
export const SAVE_SELECTED_EMAILS = 'SAVE_SELECTED_EMAILS';

export const ADD_USER_PESQUISA = 'ADD_USER_PESQUISA';
export const SELECT_ALL_USERS = 'SELECT_ALL_USERS';
export const CLEAN_CONTATOS_INTERNOS_CC = 'CLEAN_CONTATOS_INTERNOS_CC';
export const SELECT_ALL_USERS_CC = 'SELECT_ALL_USERS_CC';
export const SELECT_USER_CC = 'SELECT_USER_CC';
export const SELECT_USER = 'SELECT_USER';
export const CONTATOS_TREE_CC = 'CONTATOS_TREE_CC';
export const ADD_USER_PESQUISA_CC = 'ADD_USER_PESQUISA_CC';



export const selectAll = () => ({
    type: SELECT_ALL_USERS
});
export const selectAllCC = () => ({
    type: SELECT_ALL_USERS_CC
});

export const selectUser = user => ({
    type: SELECT_USER,
    user
});

export const selectUserCC = user => ({
    type: SELECT_USER_CC,
    user
});


export const addUser = data => ({
    type: ADD_USER_PESQUISA,
    data
});

export const addUserCC = data => ({
    type: ADD_USER_PESQUISA_CC,
    data
});

export const setTreeContent = treeContent => ({
    type: SET_TREE_CONTENT,
    treeContent
});

export const setOrganizations = organizationsContent => ({
    type: SET_ORGANIZATION_CONTENT,
    organizationsContent
});

export const setCreateDelegation = data => ({
    type: SET_CREATE_DELEGATION,
    data
});

export const setContatosInternos = data => ({
    type: CONTATOS_INTERNOS,
    data
});

export const setContactosExternos = data => ({
    type: CONTATOS_EXTERNOS,
    data
});
export const setContactosExternosTree = data => ({
    type: CONTATOS_TREE_EXTERNALS,
    data
});

export const cleanContatosInternos = userToNotClean => ({
    type: CLEAN_CONTATOS_INTERNOS,
    userToNotClean
});

export const cleanContatosInternosCC = userToNotClean => ({
    type: CLEAN_CONTATOS_INTERNOS_CC,
    userToNotClean
});

export const cleanContatosExternos = () => ({
    type: CLEAN_CONTATOS_EXTERNOS
});

export const cleanTreeContatosExternos = () => ({
    type: CLEAN_CONTATOS_TREE_EXTERNALS
});

export const startLoadContatosInternosPesquisa = () => ({
    type: LOADING_CONTATOS_INTERNOS_PESQUISA
});

export const startLoadContatosExternosPesquisa = () => ({
    type: LOADING_CONTATOS_EXTERNOS_PESQUISA
});

export const setContatosTree = data => ({
    type: CONTATOS_TREE,
    data
});

export const startLoadContatosInternos = () => ({
    type: FETCH_CONTATOS_INTERNOS
});

export const startLoadContatosExternos = () => ({
    type: FETCH_CONTATOS_EXTERNOS
});

export const setEmailData = data => ({
    type: SAVE_EMAIL_DATA,
    data: data
});

export const setSelectedEmails = data => ({
    type: SAVE_SELECTED_EMAILS,
    data: data
});

export const loadTreeFromSelectedOrganization = selected => {
    return dispatch => {
        promisseAmbiente().then(ambiente => {
            const serviceParams = {
                empresaEscolhida: selected,
                ambiente: ambiente,
                actionType: 'obterArvorePO'
            };
            ecm.model.Request.invokePluginService(
                'EdpECMServices',
                'UtilServices',
                {
                    requestParams: serviceParams,
                    requestCompleteCallback: response => {
                        dispatch(setTreeContent(convert(response.empresas)));
                    }
                }
            );
        });
    };
};

export const saveEmailData = (body, subject) => dispatch => {
    const data = {
        EDP_EmailBody: body,
        EDP_EmailSubject: subject
    };

    dispatch(setEmailData(data));
};

export const saveSelectedEmails = value => dispatch => {
    const data = {
        EDP_ToArray: value.emails.to,
        EDP_CcArray: value.emails.cc,
        EDP_BccArray: value.emails.bcc
    };

    dispatch(setSelectedEmails(data));
};

export const searchUsersByNameOrId = filter => (dispatch, getState) => {
    const {
        icmWorkItem,
    } = getState().stepReducer;
    const { _caseTypeName } = icmWorkItem;

    dispatch(startLoadContatosInternosPesquisa());
    promisseAmbiente().then(ambiente => {
        const serviceParams = {
            shortNameToGet: filter,
            repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
            ambiente,
            empresa: JSON.parse(sessionStorage.getItem('name')).company.id,
            fasePublicacao: _caseTypeName,
            actionType: 'getUsersSearch',
            username: JSON.parse(sessionStorage.name).onBehalfOf.id
        };
        ecm.model.Request.invokePluginService(
            'EdpECMServices',
            'UserServices',
            {
                requestParams: serviceParams,
                requestCompleteCallback: response => {
                    const userWithId = response.Users.map(user => ({ ...user, stringifyId: JSON.stringify(user)  } ))
                    dispatch(setContatosInternos(userWithId));
                }
            }
        );
    });
};

export const searchContacts = (type, filter, departmentId) => dispatch => {
    dispatch(startLoadContatosExternosPesquisa());
    promisseAmbiente().then(() => {
        const serviceParams = {
            contactType: type,
            contactFilter: filter,
            departmentId: departmentId
        };
        ecm.model.Request.invokePluginService(
            'EdpECMServices',
            'EdpContactService',
            {
                requestParams: serviceParams,
                requestCompleteCallback: response => {
                    dispatch(setContactosExternos(response.contacts));
                }
            }
        );
    });
};

export const getExternalsTree = filter => dispatch => {
    promisseAmbiente().then(() => {
        const requestParams = {
            entityFilter: filter
        };

        console.log(requestParams);
        ecm.model.Request.invokePluginService(
            'EdpECMServices',
            'EdpEntityDepartmentService',
            {
                requestParams,
                requestCompleteCallback: response => {
                    dispatch(setContactosExternosTree(response.entities));
                }
            }
        );
    });
};

export const loadUserFromTree = node => (dispatch, getState) => {
    promisseAmbiente().then(ambiente => {
        let requestParams = {};
        if (node.id === 'base' || node.id === 'empresaRoot') return;
        dispatch(startLoadContatosInternos());
        switch (node.actionType) {
            case 'getPublicList':
            requestParams = {
                repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
                realmName: 'dc=edp,dc=pt',
                ambiente: ambiente ,
                listName: node.listName,
                listId: node.listId,
                actionType: 'getUsersLPU'
            };
                break;
            case 'getListNameByUser':
                requestParams = {
                    repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
                    realmName: 'dc=edp,dc=pt',
                    ambiente: ambiente ,
                    listName: node.listName,
                    listId: node.listId,
                    actionType: 'getUsersLPR'
                };
                break;

            case 'getMyTeam':
                requestParams = {
                    repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
                    poEscolhida: `${ambiente}_${
                        JSON.parse(sessionStorage.getItem('name')).organizationPosition.id
                    }`,
                    realmName: 'dc=edp,dc=pt',
                    ambiente: ambiente ,
                    username: JSON.parse(sessionStorage.name).onBehalfOf.id,
                    actionType: 'getMyTeamUsersReadDown1st'
                };
                break;
            case 'obterArvorePO':
                requestParams = {
                    repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
                    poEscolhida: `${ambiente}_${node.txtNomeGrupo}`,
                    realmName: 'dc=edp,dc=pt',
                    ambiente: ambiente ,
                    actionType: 'getUsersPO'
                };
                break;
            default:
                console.error('ACTION TYPE NAO ENCONTRADO');
                return;
        }

        ecm.model.Request.invokePluginService(
            'EdpECMServices',
            'UserServices',
            {
                requestParams,
                requestCompleteCallback: response => {
                    const genericUsers = response.Users || response.users;
                    const userWithId = genericUsers.map(user => ({ ...user, stringifyId: JSON.stringify(user) }) )
                    dispatch(setContatosTree(userWithId));
                }
            }
        );
    });
};

export const getEmpresas = () => dispatch => {
    dispatch(startLoadContatosExternos());
    promisseAmbiente().then(ambiente => {
        const listaEmpresaPrivaParams = {
            repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
            quantidadeEmpresas: 'todas',
            ambiente: ambiente,
            actionType: 'getEmpresas',
            visibility: '0'
        };
        ecm.model.Request.invokePluginService(
            'EdpECMServices',
            'UserServices',
            {
                requestParams: listaEmpresaPrivaParams,
                requestCompleteCallback: response => {
                    dispatch(setOrganizations(response.empresas));
                }
            }
        );
    });
};

const getEmpresaPrivada = () =>
    new Promise(resolve => {
        promisseAmbiente().then(ambiente => {
            const listaEmpresaPrivadaParams = {
                repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
                realmName: 'dc=edp,dc=pt',
                ambiente,
                actionType: 'getListNameByUser'
            };
            ecm.model.Request.invokePluginService(
                'EdpECMServices',
                'UserServices',
                {
                    requestParams: listaEmpresaPrivadaParams,
                    requestCompleteCallback: response => {
                        resolve(convert(response.listas));
                    }
                }
            );
        });
    });

const getEmpresasPublicasTree = () =>
    new Promise(resolve => {
        promisseAmbiente().then(ambiente => {
            const listaEmpresaPublicaParams = {
                repositoryId: ecm.model.desktop.getDefaultRepositoryId(),
                realmName: 'dc=edp,dc=pt',
                ambiente: ambiente,
                actionType: 'getPublicList'
            };
            ecm.model.Request.invokePluginService(
                'EdpECMServices',
                'UserServices',
                {
                    requestParams: listaEmpresaPublicaParams,
                    requestCompleteCallback: response => {
                        console.log(
                            '=== getEmpresasPublicasTree ===',
                            response
                        );
                        resolve(convert(response.listas));
                    }
                }
            );
        });
    });

const getEmpresa = empresaSelecionada =>
    new Promise(resolve => {
        promisseAmbiente().then(ambiente => {
            const requestParams = {
                empresaEscolhida: empresaSelecionada ? empresaSelecionada : JSON.parse(sessionStorage.getItem('name')).company.id,
                ambiente: `${ambiente}_`,
                actionType: 'obterArvorePO'
            };
            ecm.model.Request.invokePluginService('EdpECMServices','UtilServices', {
                requestParams,
                requestCompleteCallback: response => resolve(convert(response.empresas))
            });
        });
    });

export const GET_EMPRESAS = 'GET_EMPRESAS';
export const setEmpresas = organizationsContent => ({
    type: GET_EMPRESAS,
    organizationsContent
});

export const loadAllTrees = empresaEscolhida => dispatch => {
    const promises = [];
    promises.push(getEmpresasPublicasTree());
    promises.push(getEmpresaPrivada());
    promises.push(getEmpresa(empresaEscolhida));
    Promise.all(promises).then(response => {
        console.log('=== all trees ===', response);
        dispatch(setEmpresas(response));
    });
};

export function convert(rows, optionsIn) {
    let options = optionsIn || {};
    let idProp = options.id || 'id';
    let parentProp = options.parent || 'parent';
    let childProp = options.children || 'children';

    function exists(rows, parent) {
        for (let i = 0; i < rows.length; i++) {
            if (rows[i][idProp] == parent) return true;
        }
        return false;
    }

    let nodes = [];
    // get the top level nodes
    for (let i = 0; i < rows.length; i++) {
        let row = rows[i];
        if (row.id != 'empresaRoot') {
            if (!exists(rows, row[parentProp])) {
                nodes.push(Object.assign({}, row));
            }
        } else {
            row.name = 'Toda a empresa';
            if (!exists(rows, row[parentProp])) {
                nodes.push(Object.assign({}, row));
            }
        }
    }

    let toDo = [];
    for (let i = 0; i < nodes.length; i++) {
        toDo.push(nodes[i]);
    }

    while (toDo.length) {
        let node = toDo.shift();

        // the parent node
        // get the children nodes
        for (let i = 0; i < rows.length; i++) {
            let row = rows[i];
            if (row[parentProp] == node[idProp]) {
                let child = Object.assign({}, row);
                node[childProp] = node[childProp] || [];
                node[childProp].push(child);
                toDo.push(child);
            }
        }
    }

    return nodes;
}