export const FETCH_PROCESSOS_BEGIN = 'FETCH_PROCESSOS_BEGIN';
export const FETCH_PROCESSOS_SUCCESS = 'FETCH_PROCESSOS_SUCCESS';
export const SET_ROW_INFOS = 'SET_ROW_INFOS';

export const SET_STEP_DESCRIPTION = 'SET_STEP_DESCRIPTION';
export const SET_STEP_HEADER_TITLE = 'SET_STEP_HEADER_TITLE';

export const FETCH_DOCUMENT_SUCCESS = 'FETCH_DOCUMENT_SUCCESS';

export const fetchProcessosSuccess = (results, principalDocId) => ({
    type: FETCH_PROCESSOS_SUCCESS,
    results,
    principalDocId
});

export const rowInfosSelected = rowInfos => ({
    type: SET_ROW_INFOS,
    rowInfos
});

export const fetchDocument = document => ({
    type: FETCH_DOCUMENT_SUCCESS,
    document
});

export const getAssociateDocs = caseFolderId => dispatch => {
    const repositoryId = ecm.model.desktop.defaultRepositoryId;
    const documentId = caseFolderId;
    console.log(
        '====CALLING GETCASECONTENT WITH ======',
        repositoryId,
        documentId
    );
    window.getCaseContent(repositoryId, documentId, res => {
        const { docs,Principal } = res;
        console.log(
            '====RESPONSE FRO CASES CONTENT TO  CASE FOLDER ======',
            res
        );
        const principalDocIDarray = Principal && Principal.DocID?Principal.DocID.split(","):undefined;
        dispatch(fetchProcessosSuccess(res.caseResultSet, principalDocIDarray?principalDocIDarray[principalDocIDarray.length-1]:principalDocIDarray));
    });
};
const getDocumentById = docId =>
    new Promise(resolve => {
        console.log('==== docId getDocumentById ====', docId);
        const repository = ecm.model.desktop.getDefaultRepository();
        repository.retrieveItem(docId, fullDocument => {
            resolve(fullDocument);
        });
    });

export const getDocumentProcess = docId => dispatch => {
    getDocumentById(docId).then(fullDocument => {
        console.log('==== docId ====', docId);
        dispatch(fetchDocument(fullDocument));
    });
};

export const setStepDescription = stepDescription => ({
    type: SET_STEP_DESCRIPTION,
    stepDescription
});

export const setStepHeaderTitle = stepTitle => ({
    type: SET_STEP_HEADER_TITLE,
    stepTitle
});
