
export const getMimeClass = mimeType => {
    const ICONS = {
        'application/pdf': 'PDF',
        'application/vnd.openxmlformats-officedocument.wordprocessingml.document':
            'WORD',
        'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':'EXCEL',
        'application/process': 'PROCESSO',
        'application/vnd.ms-outlook':'MESSAGE',
        'application/vnd.mspowerpoint':'PPT',
        'image/jpeg':'IMAGE',
        'image/png':'IMAGE',
        'image/bmp':'IMAGE',
        'text/*':'TXT',
        folder: 'PASTA'
    };
    return ICONS[mimeType] ? ICONS[mimeType] : "DEFAULT";
};

export const isEmpty = obj => {
    for (var key in obj) {
        if (obj.hasOwnProperty(key)) return false;
    }
    return true;
};

export const getFullAttributes = item => {
    return new Promise(resolve => {
        getItemByID(null, item.id.split(',').pop(), itemComplete => {
            resolve(itemComplete);
        });
    });
}

export const stringCleaner = string => string.replace(/[\|&;\$%@'<>\(\)\+,{}]/g, '').split(' ').join('');
